/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.config.shared;

import java.util.List;

public class CfgArray extends AbstractCfgObject {
  private final List<AbstractCfgObject> items;

  public CfgArray(SourceInfo source, List<AbstractCfgObject> items) {
    super(source);
    this.items = items;
  }

  public List<AbstractCfgObject> getItems() {
    return items;
  }

  @Override
  public int resolveInt() {
    throw new WrongTypeException("Array can't be used as an int " + getSource());
  }

  @Override
  public double resolveDouble() {
    throw new WrongTypeException("Array can't be used as an double " + getSource());
  }

  @Override
  public String resolveString() {
    throw new WrongTypeException("Array can't be used as an String " + getSource());
  }

  @Override
  public CfgObject resolveObject() {
    throw new WrongTypeException("Array can't be used as an Object " + getSource());
  }

  @Override
  public CfgArray resolveArray() {
    return this;
  }

  @Override
  public void accept(CfgVisitor visitor) {
    visitor.visitArray(this);
  }
}
