/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
/* Generated By:JavaCC: Do not edit this line. GxtThemeConfigParser.java */
package com.sencha.gxt.themebuilder.config.shared;

import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

public class GxtThemeConfigParser implements GxtThemeConfigParserConstants {
  private final Stack<AbstractCfgObject> stack = new Stack<AbstractCfgObject>();
  private final Stack<String> path = new Stack<String>();
  private void push(AbstractCfgObject obj) {
    stack.push(obj);
  }
  private AbstractCfgObject pop(AbstractCfgObject obj) {
    AbstractCfgObject actual = pop();
    assert actual == obj;
    return actual;
  }
  private AbstractCfgObject pop() {
    return stack.pop();
  }
  private AbstractCfgObject peek() {
    return stack.peek();
  }

  private String parseString(String s) {
    s = s.substring(1, s.length() - 1);
    s = s.replace("\u005c\u005cn", "\u005cn");
    s = s.replace("\u005c\u005cr", "\u005cr");
    s = s.replace("\u005c\u005ct", "\u005ct");
    s = s.replace("\u005c\u005c'", "\u005c'");
    s = s.replace("\u005c\u005c\u005c"", "\u005c"");
    s = s.replace("\u005c\u005c\u005c\u005c", "\u005c\u005c");
    return s;
  }

  private SourceInfo source(Token token) {
    StringBuilder sb = new StringBuilder();
    for (String k : path) {
      assert k != null && k.length() != 0;
      if (sb.length() != 0) {
        sb.append(".");
      }
      sb.append(k);
    }
    return new SourceInfo(token.beginLine, token.beginColumn, sb.toString());
  }

  final public CfgObject file() throws ParseException {
  CfgObject outer = new CfgObject(source(token), null);
  push(outer);
  String key = null;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EOL:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      jj_consume_token(EOL);
    }
    jj_consume_token(IDENTIFIER);
                          key = token.image; path.push(key);
    block();
    assert path.peek().equals(key);
    path.pop();
    CfgObject inner = pop().resolveObject();
    assert inner != null;
    pop(outer);
    assert stack.isEmpty();
    outer.put(key, inner);
    {if (true) return outer;}
    throw new Error("Missing return statement in function");
  }

  final public void block() throws ParseException {
  CfgObject obj = new CfgObject(source(token), stack.peek().resolveObject());
  push(obj);
    jj_consume_token(LBRACE);
    label_2:
    while (true) {
      jj_consume_token(EOL);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EOL:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_2;
      }
    }
    blockContents();
    jj_consume_token(RBRACE);
  }

  final public void blockContents() throws ParseException {
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_3;
      }
      blockLine();
    }
  }

  final public void blockLine() throws ParseException {
  String key = null;
    jj_consume_token(IDENTIFIER);
                 key = token.image;
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 26:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_4;
      }
      jj_consume_token(26);
      jj_consume_token(IDENTIFIER);
                      key += "." + token.image;
    }
    assert key != null;
    path.push(key);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      block();
      break;
    case EQUALS:
      jj_consume_token(EQUALS);
      expr();
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 27:
      jj_consume_token(27);
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
    label_5:
    while (true) {
      jj_consume_token(EOL);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EOL:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_5;
      }
    }
    assert path.peek().equals(key);
    path.pop();
    AbstractCfgObject obj = pop();
    assert obj != null;
    peek().resolveObject().put(key, obj);
  }

  final public void expr() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
    case FLOATING_POINT:
    case DBL_QUOTE_STRING:
    case SGL_QUOTE_STRING:
    case UTIL_PREFIX:
    case IDENTIFIER:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER:
      case FLOATING_POINT:
      case DBL_QUOTE_STRING:
      case SGL_QUOTE_STRING:
        constant();
        break;
      case IDENTIFIER:
        reference();
        break;
      case UTIL_PREFIX:
        funcCall();
        break;
      default:
        jj_la1[7] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
      case MULTIPLY:
      case DIVIDE:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
          jj_consume_token(PLUS);
          break;
        case MINUS:
          jj_consume_token(MINUS);
          break;
        case MULTIPLY:
          jj_consume_token(MULTIPLY);
          break;
        case DIVIDE:
          jj_consume_token(DIVIDE);
          break;
        default:
          jj_la1[8] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        String op = token.image;
        AbstractCfgObject lhs = pop();
        expr();
        push(new CfgExpression(source(token), lhs, pop(), op));
        break;
      default:
        jj_la1[9] = jj_gen;
        ;
      }
      break;
    case MINUS:
      jj_consume_token(MINUS);
      expr();
      push(new CfgExpression(source(token), new CfgDoubleLiteral(source(token), 0), pop(), CfgExpression.Op.MINUS));
      break;
    case LBRACKET:
      array();
      break;
    case LBRACE:
      block();
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void negativeNumber() throws ParseException {
    jj_consume_token(MINUS);
    positiveNumber();
    push(new CfgExpression(source(token), new CfgDoubleLiteral(source(token), 0), pop(), CfgExpression.Op.MINUS));
  }

  final public void array() throws ParseException {
  List<AbstractCfgObject> items = new ArrayList<AbstractCfgObject>();
    jj_consume_token(LBRACKET);
    label_6:
    while (true) {
      jj_consume_token(EOL);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EOL:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_6;
      }
    }
    expr();
                    items.add(pop());
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[12] = jj_gen;
        break label_7;
      }
      jj_consume_token(COMMA);
      label_8:
      while (true) {
        jj_consume_token(EOL);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EOL:
          ;
          break;
        default:
          jj_la1[13] = jj_gen;
          break label_8;
        }
      }
      expr();
                                                                items.add(pop());
    }
    label_9:
    while (true) {
      jj_consume_token(EOL);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EOL:
        ;
        break;
      default:
        jj_la1[14] = jj_gen;
        break label_9;
      }
    }
    jj_consume_token(RBRACKET);
    push(new CfgArray(source(token), items));
  }

  final public void constant() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DBL_QUOTE_STRING:
    case SGL_QUOTE_STRING:
      string();
      break;
    case INTEGER:
    case FLOATING_POINT:
      positiveNumber();
      break;
    default:
      jj_la1[15] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void string() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DBL_QUOTE_STRING:
      jj_consume_token(DBL_QUOTE_STRING);
    push(new CfgStringLiteral(source(token), parseString(token.image)));
      break;
    case SGL_QUOTE_STRING:
      jj_consume_token(SGL_QUOTE_STRING);
    push(new CfgStringLiteral(source(token), parseString(token.image)));
      break;
    default:
      jj_la1[16] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void positiveNumber() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER:
      jj_consume_token(INTEGER);
    push(new CfgIntLiteral(source(token), Integer.parseInt(token.image)));
      break;
    case FLOATING_POINT:
      jj_consume_token(FLOATING_POINT);
    push(new CfgDoubleLiteral(source(token), Double.parseDouble(token.image)));
      break;
    default:
      jj_la1[17] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void reference() throws ParseException {
  String key = null;
    jj_consume_token(IDENTIFIER);
                 key = token.image;
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 26:
        ;
        break;
      default:
        jj_la1[18] = jj_gen;
        break label_10;
      }
      jj_consume_token(26);
      jj_consume_token(IDENTIFIER);
                                                          key += "." + token.image;
    }
    push(new CfgReference(source(token), peek().resolveObject(), key, path.peek()));
  }

  final public void funcCall() throws ParseException {
  String func = null;
  List<AbstractCfgObject> args = null;
    jj_consume_token(UTIL_PREFIX);
    jj_consume_token(IDENTIFIER);
                 func = token.image;
    jj_consume_token(LPAREN);
    args = args();
    jj_consume_token(RPAREN);
    push(new CfgFuncCall(source(token), peek().resolveObject(), func, args));
  }

  final public List<AbstractCfgObject> args() throws ParseException {
  List<AbstractCfgObject> args = new ArrayList<AbstractCfgObject>();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
    case LBRACKET:
    case MINUS:
    case INTEGER:
    case FLOATING_POINT:
    case DBL_QUOTE_STRING:
    case SGL_QUOTE_STRING:
    case UTIL_PREFIX:
    case IDENTIFIER:
      arg();
            args.add(pop());
      label_11:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[19] = jj_gen;
          break label_11;
        }
        jj_consume_token(COMMA);
        arg();
                                                 args.add(pop());
      }
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
    {if (true) return args;}
    throw new Error("Missing return statement in function");
  }

  final public void arg() throws ParseException {
    expr();
  }

  /** Generated Token Manager. */
  public GxtThemeConfigParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[21];
  static private int[] jj_la1_0;
  static {
      jj_la1_init_0();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x40,0x40,0x2000000,0x4000000,0x40080,0x8000000,0x40,0x3e80000,0x3c000,0x3c000,0x3e88280,0x40,0x2000,0x40,0x40,0xe80000,0xc00000,0x280000,0x4000000,0x2000,0x3e88280,};
   }

  /** Constructor with InputStream. */
  public GxtThemeConfigParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public GxtThemeConfigParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new GxtThemeConfigParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  /** Constructor. */
  public GxtThemeConfigParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new GxtThemeConfigParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  /** Constructor with generated Token Manager. */
  public GxtThemeConfigParser(GxtThemeConfigParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(GxtThemeConfigParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 21; i++) jj_la1[i] = -1;
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[28];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 21; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 28; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

}
