/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.graphics.shared;

import com.google.gwt.dom.client.Document;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.themebuilder.graphics.shared.Color;

public class GraphicsUtilColorManager {
  public static Color getColorByName(String name) {
    XElement elt = Document.get().createDivElement().cast();
    elt.getStyle().setColor(name);

    String rgb = getComputedColor(elt).trim();
    String[] colors = rgb.substring("rgb(".length(),rgb.length() - ")".length()).split(",");
    int[] ints = new int[4];
    for (int i = 0; i < colors.length; i++) {
      ints[i] = Integer.parseInt(colors[i].trim());
    }


    return new Color(ints[0], ints[1], ints[2]);
  }
  private static native String getComputedColor(XElement elt) /*-{
    return $doc.defaultView.getComputedStyle(elt, null).getPropertyValue("color");
  }-*/;
}
