/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.slicer.client.data;

/**
 * @see com.sencha.tools.slicer.Model.Widget
 */
public interface WidgetData {

  /**
   * @see com.sencha.util.Side
   */
  public enum GradientDir {
    top, left, bottom, right
  }

  GradientDir getGradient();

  void setGradient(GradientDir dir);

  String getId();

  void setId(String id);

  BorderData getBorder();

  void setBorder(BorderData borders);

  BoxData getBox();

  void setBox(BoxData boxData);

  RadiusData getRadius();

  void setRadius(RadiusData radius);

  Slices getSlices();

  void setSlices(Slices slices);

  /**
   * @see com.sencha.tools.slicer.NullableSide
   */
  public enum Side {
    TOP, RIGHT, BOTTOM, LEFT, NONE
  }

  Side getStretch();

  void setStretch(Side side);

  Boolean isSprite();

  void setSprite(Boolean sprite);
}
