/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.slicer.client.job.button;

import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData;
import com.sencha.gxt.themebuilder.slicer.client.job.AbstractJob;
import com.sencha.gxt.widget.core.client.button.CellButtonBase;
import com.sencha.gxt.widget.core.client.button.TextButton;

/**
 *
 */
public class ButtonJob extends AbstractJob<CellButtonBase<?>> {

  @Override
  protected CellButtonBase<?> createWidget() {
    CellButtonBase<?> button = new TextButton();
    button.setText("button");
    return button;
  }

  @Override
  public void collectWidgetData(JobCallback callback) {
    doEvent();
    WidgetData buttonData = createWidgetData(getState());

    setRadius(buttonData, (XElement) widget.getElement().getFirstChildElement());
    setBorders(buttonData, (XElement) widget.getElement().getFirstChildElement());
    setBox(widget.getElement().getFirstChildElement(), buttonData.getBox());

    buttonData.setGradient(WidgetData.GradientDir.top);
    buttonData.setStretch(WidgetData.Side.BOTTOM);

    buttonData.getSlices().setCorners("button/" + getType() + "button" + getState() + ".png");
    buttonData.getSlices().setSides("button/" + getType() + "button" + getState() + ".png");
    buttonData.getSlices().setBg("button/" + getType() + "button" + getState() + "-background.png");

    callback.addWidgetData(buttonData);
  }

  protected void doEvent() {

  }

  protected String getState() {
    return "";
  }

  protected String getType() {
    return "";
  }

}
