/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.slicer.client.job.field;

import com.sencha.gxt.themebuilder.slicer.client.data.BoxData;
import com.sencha.gxt.widget.core.client.Slider;

/**
 *
 */
public class SliderVerticalJob extends SliderJob {

  @Override
  protected Slider createWidget() {
    return createWidget(true);
  }

  @Override
  public void collectWidgetData(JobCallback callback) {

    sliceThumb("Vertical", callback);


    sliceIt("VerticalTop", callback, new BoxUpdate() {
      @Override
      public void run(BoxData boxData) {
        boxData.setH(getCapSize());
      }
    });

    sliceIt("VerticalBottom", callback, new BoxUpdate() {
      @Override
      public void run(BoxData boxData) {
        int capSize = getCapSize();
        boxData.setY(boxData.getY() + (SLIDER_SIZE - capSize));
        boxData.setH(capSize);
      }
    });

    sliceIt("VerticalMiddle", callback, new BoxUpdate() {
      @Override
      public void run(BoxData boxData) {
        boxData.setY(boxData.getY() + getCapSize());
        boxData.setH(2);
      }
    });
  }

  private int getCapSize() {
    return Math.max(details.field().slider().thumbHeight() / 2, details.field().slider().trackRadius());
  }
}
