/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.slicer.client.job.info;

import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Element;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.google.gwt.user.client.DOM;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.core.client.util.Util;
import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData;
import com.sencha.gxt.themebuilder.slicer.client.job.AbstractJob;
import com.sencha.gxt.widget.core.client.Component;
import com.sencha.gxt.widget.core.client.info.DefaultInfoConfig;
import com.sencha.gxt.widget.core.client.info.Info;

/**
 *
 */
public class InfoJob extends AbstractJob<InfoJob.NonDisappearingInfo> {

  public static class NonDisappearingInfo extends Component {
    private static class MyInfoConfig extends DefaultInfoConfig {

      private DefaultInfoConfigAppearance appearance;

      public MyInfoConfig() {
        super(Util.NBSP_SAFE_HTML, Util.NBSP_SAFE_HTML);

        this.appearance = GWT.create(DefaultInfoConfigAppearance.class);
      }

      protected SafeHtml render() {
        SafeHtmlBuilder builder = new SafeHtmlBuilder();
        appearance.render(builder, getTitle(), getMessage());
        return builder.toSafeHtml();
      }
    }

    private MyInfoConfig config;

    public NonDisappearingInfo() {
      config = new MyInfoConfig();

      setElement(DOM.createDiv().<Element>cast());
      Info.InfoAppearance appearance = GWT.create(Info.InfoAppearance.class);

      SafeHtmlBuilder sb = new SafeHtmlBuilder();
      appearance.render(sb);
      getElement().setInnerSafeHtml(sb.toSafeHtml());

      XElement target = appearance.getContentElement(getElement());
      target.setInnerSafeHtml(config.render());


      setHeight(config.getHeight());
      setWidth(config.getWidth());
    }
  }

  @Override
  protected NonDisappearingInfo createWidget() {
    NonDisappearingInfo info = new NonDisappearingInfo();

    return info;
  }

  @Override
  public void collectWidgetData(JobCallback callback) {

    WidgetData data = createWidgetData("info");

    setBorders(data, (XElement) widget.getElement().getFirstChildElement());
    setRadius(data, (XElement) widget.getElement().getFirstChildElement());

    setBox(widget, data.getBox());

    data.getSlices().setCorners("info/corner.png");
    data.getSlices().setBg("info/background.png");
    data.getSlices().setSides("info/side.png");

    callback.addWidgetData(data);
  }
}
