/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.slicer.client.job.tip;

import com.google.gwt.dom.client.Element;
import com.google.gwt.safehtml.shared.SafeHtmlUtils;
import com.google.gwt.user.client.ui.InsertPanel.ForIsWidget;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.core.client.dom.XDOM;
import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData;
import com.sencha.gxt.themebuilder.slicer.client.job.AbstractJob;
import com.sencha.gxt.widget.core.client.ComponentHelper;
import com.sencha.gxt.widget.core.client.tips.Tip;

public class TipJob extends AbstractJob<Tip> {
  public static class ToolTipWrapper extends Widget {
    public ToolTipWrapper(Tip tip) {
      setElement(XDOM.create(
          SafeHtmlUtils.fromSafeConstant("<div style='position:relative; width:100px; height:100px;'></div>")
      ).<Element>cast());
      getElement().appendChild(tip.getElement());
      ComponentHelper.doAttach(tip);
      ComponentHelper.doDetach(tip);
    }
  }

  @Override
  public void go(ForIsWidget parent) {
    parent.add(new Label(this.getClass().getName()));
    widget = createWidget();
    ToolTipWrapper wrap = new ToolTipWrapper(widget);
    parent.add(wrap);
  }

  @Override
  protected Tip createWidget() {
    Tip tip = new Tip();
    tip.setPixelSize(50, 50);
    tip.setShadow(false);
    return tip;
  }

  @Override
  public void collectWidgetData(JobCallback callback) {
    WidgetData data = createWidgetData("tip");

    setBorders(data, widget.getElement());
    setRadius(data, widget.getElement());

    setBox(widget, data.getBox());

    data.getSlices().setCorners(getDirectory() + "/" + getImagePrefix() + ".png");
    data.getSlices().setBg(getDirectory() + "/" + getImagePrefix() + "-background.png");
    data.getSlices().setSides(getDirectory() + "/" + getImagePrefix() + ".png");

    callback.addWidgetData(data);
  }

  protected String getDirectory() {
    return "tips";
  }

  protected String getImagePrefix() {
    return "tip";
  }
}
