/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.slicer.client.job.toolbar;

import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData;
import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData.Side;
import com.sencha.gxt.themebuilder.slicer.client.job.AbstractJob;
import com.sencha.gxt.widget.core.client.Component;
import com.sencha.gxt.widget.core.client.button.TextButton;
import com.sencha.gxt.widget.core.client.container.VerticalLayoutContainer;
import com.sencha.gxt.widget.core.client.container.VerticalLayoutContainer.VerticalLayoutData;
import com.sencha.gxt.widget.core.client.toolbar.SeparatorToolItem;
import com.sencha.gxt.widget.core.client.toolbar.ToolBar;

/**
 *
 */
public class ToolBarJob extends AbstractJob<Component> {

  private ToolBar toolBar;
  private SeparatorToolItem separatorToolItem;

  @Override
  protected Component createWidget() {
    toolBar = new ToolBar();

    VerticalLayoutContainer container = new VerticalLayoutContainer();
    container.setPixelSize(300, 50);

    toolBar.add(new TextButton("foo"));
    separatorToolItem = new SeparatorToolItem();
    toolBar.add(separatorToolItem);

    container.add(toolBar, new VerticalLayoutData(1, -1));

    return container;
  }

  @Override
  public void collectWidgetData(JobCallback callback) {

    WidgetData toolBarData = createWidgetData("toolbar");
    setBox(toolBar, toolBarData.getBox());
    setBorders(toolBarData, 0, 0, 1, 0); // FIXME - magic numbers
    toolBarData.getSlices().setBg("toolbar/background.png");
    toolBarData.setStretch(Side.BOTTOM);
    callback.addWidgetData(toolBarData);


    WidgetData separatorData = createWidgetData("separator");
    setBox(separatorToolItem, separatorData.getBox());
    separatorData.getSlices().setFull_capture("toolbar/separator.png");
    callback.addWidgetData(separatorData);
  }
}
